
ENV["VAGRANT_EXPERIMENTAL"] = "disks"
Vagrant.configure("2") do |config|
  config.vm.define "whacamole" do |whacamole|
    whacamole.vm.box = "ubuntu/focal64"
    whacamole.vm.hostname = "potato"
    whacamole.vm.provider :virtualbox
    whacamole.vm.disk :disk, size: "45GB", primary: true

    whacamole.vm.disk :disk, size: "10GB", name: "disk-2nd"
    
    whacamole.vm.provision "shell", inline: <<-SHELL
      mkfs.ext4 /dev/sdc
      mkdir -p /mnt/storage
      mount /dev/sdc /mnt/storage
    SHELL

    whacamole.vm.provision "shell", inline: "sudo apt-get update"
    whacamole.vm.provision "shell", inline: "sudo apt-get install "
    whacamole.vm.provision "shell", inline: "sudo apt-get install apt-transport-https "
    whacamole.vm.provision "shell", inline: "sudo apt-get install ca-certificates "
    whacamole.vm.provision "shell", inline: "sudo apt-get install curl "
    whacamole.vm.provision "shell", inline: "sudo apt-get install gnupg "
    whacamole.vm.provision "shell", inline: "sudo apt-get install lsb-release"

    whacamole.vm.provision "shell", inline: "curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo gpg --dearmor -o /usr/share/keyrings/docker-archive-keyring.gpg"


    whacamole.vm.provision "shell", inline: <<-SHELL
      echo \
      "deb [arch=amd64 signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] https://download.docker.com/linux/ubuntu \
      $(lsb_release -cs) stable" | sudo tee /etc/apt/sources.list.d/docker.list > /dev/null
    SHELL

    whacamole.vm.provision "shell", inline: "sudo apt-get update"
    whacamole.vm.provision "shell", inline: "sudo apt-get install docker-ce docker-ce-cli containerd.io -y"
    whacamole.vm.provision "shell", inline: "sudo apt-get install docker-ce=5:20.10.5~3-0~ubuntu-focal docker-ce-cli=5:20.10.5~3-0~ubuntu-focal containerd.io -y"
    whacamole.vm.provision "shell", inline: "sudo touch /etc/docker/deamon.json"
    whacamole.vm.provision "shell", inline: <<-SHELL
      sudo echo "{\
      "data-root": \"/mnt/storage\"\
      }" > /etc/docker/deamon.json
    SHELL
    whacamole.vm.provision "shell", inline: "sudo rsync -aP /var/lib/docker/ /mnt/storage"
    whacamole.vm.provision "shell", inline: "sudo mv /var/lib/docker /var/lib/docker.old"
    whacamole.vm.provision "shell", inline: "sudo service docker start"
    whacamole.vm.provision "shell", inline: "sudo rm -rf /var/lib/docker.old"

  end
end
